#ifndef __stream__
#define __stream__

#include "type.h"

class BitStream
{ public:

    char Name[32];

    BitStream();
   ~BitStream();

    bool Open (const char* name, const char* attr="");
    bool Close();

    bool IsEndOfStream();

    bool PutStream(DWord  code, Byte length);
    bool GetStream(DWord* code, Byte length=1);

    DWord StreamIn(Byte length);

    void Align(bool flag);

    BitStream& operator<<( const char*   str   );
    BitStream& operator<<( const DWord&  dword );
    
  protected:

    bool ByteStuffing;

  private:
    Byte Buffer, BufferLength;
    bool Put(Byte  val);
    bool Get(Byte* val);
};

#endif
